

function dbFetch() {
    fetch("https://raw.githubusercontent.com/maniekx86/trollblocker-database/main/database_troll.txt") // fetch database with url
            .then(response => response.text())
            .then(text => {
                var d_troll = text.split("\n");
                // remove last element
                d_troll.pop();
                fetch("https://raw.githubusercontent.com/maniekx86/trollblocker-database/main/database_jumpscare.txt") // fetch database with url
            .then(response => response.text())
            .then(text => {
                var d_jumpscare = text.split("\n");
                // remove last element
                d_jumpscare.pop();
                fetch("https://raw.githubusercontent.com/maniekx86/trollblocker-database/main/database_rickroll.txt") // fetch database with url
            .then(response => response.text())
            .then(text => {
                var d_rickroll = text.split("\n");
                d_rickroll.pop();
                fetch("https://raw.githubusercontent.com/maniekx86/trollblocker-database/main/database_other.txt") // fetch database with url
            .then(response => response.text())
            .then(text => {
                var d_other = text.split("\n");
                d_other.pop();
                // calculate total number of lines
                var total = d_troll.length + d_jumpscare.length + d_rickroll.length + d_other.length;
                chrome.storage.sync.set({
                    database: {
                        lastUpdate: new Date().getTime(),
                        totalLinks: total,
                        data_troll: d_troll,
                        data_jumpscare: d_jumpscare,
                        data_rickroll: d_rickroll,
                        data_other: d_other
                    }
                });
            
            })
        })
    })
 })
}


chrome.runtime.onInstalled.addListener(function() {
    chrome.storage.sync.set({
        database: [],
        enabled_funcs: { "troll": true, "jumpscare": true, "rickroll": false, "other": true }
    })
    dbFetch();
});



chrome.storage.sync.get("database", function(result) {
    try {
      if ((result.database.lastUpdate < new Date().getTime() - 2592000000)|| result.database == []) {
        dbFetch();
      }
    } catch(e) {
      dbFetch();  
    }
})

// handle messages to update db
chrome.runtime.onMessage.addListener(function(request, sender, sendResponse) {
    if (request.action == "updateDatabase") {
        dbFetch();
    }
    // response
    sendResponse({
        farewell: "goodbye"
    });
});


